package cokr.xit.fims.rdca.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;
import cokr.xit.fims.rdca.Rdamt;
import cokr.xit.fims.rdca.RdamtQuery;

/** 감액 대장 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2024-02-01	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("rdamtMapper")
public interface RdamtMapper extends AbstractMapper {

	/**지정한 조건에 따라 감액 대장 목록을 조회하여 반환한다.<br />
	 * @param req 감액 대장 조회 조건
	 * @return 감액 대장 목록
	 */
	List<DataObject> selectRdamtList(RdamtQuery req);

	/**지정한 조건에 따라 감액 대장 객체들을 반환한다.
	 * @param req 감액 대장 조회 조건
	 * @return 감액 대장 객체 목록
	 */
	List<DataObject> selectRdamts(RdamtQuery req);

	/**지정한 조건에 따라 감액 대장 객체 1건을 반환한다.
	 * @param req 감액 대장 조회 조건
	 * @return 감액 대장 객체
	 */
	default DataObject selectRdamtInfo(RdamtQuery req) {
		// 삭제 여부 확인
		if (req.getDelYn() == null) {
			req.setDelYn("N");
		}
		// 기본 정렬
		if (req.getOrderBy() == null) {
			req.setOrderBy("R.RDAMT_ID DESC");
		}

		List<DataObject> rdcamts = selectRdamts(req);

		return !rdcamts.isEmpty() ? rdcamts.get(0) : null;
	}

	/**감액 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"rdcamt" - 감액 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertRdamt(Map<String, Object> params);

	/**감액 대장 정보를 등록한다.
	 * @param rdamt 감액 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(Rdamt rdamt) {
		return rdamt != null && insertRdamt(params().set("rdamt", rdamt)) == 1;
	}

	/**감액 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"rdamt" - 감액 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateRdamt(Map<String, Object> params);

	/**감액 대장 정보를 수정한다.
	 * @param rdamt 감액 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(Rdamt rdamt) {
		return rdamt != null && updateRdamt(params().set("rdamt", rdamt)) == 1;
	}

	/**지정한 감액 대장을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"rdcamt" - 감액 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteRdamt(Map<String, ?> params);

	/**감액 대장 정보를 삭제한다.
	 * @param rdamt 감액 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(Rdamt rdamt) {
		return rdamt != null && deleteRdamt(params().set("rdamt", rdamt)) == 1;
	}

}
